/*
 * @Author: eycode
 * @Date: 2021-11-24 18:40:07
 * @LastEditTime: 2022-01-26 15:27:18
 * @LastEditors: eycode
 * @Description: node setETC.js d:/test/assets 1
 * https://www.chuyouxiang.com/archives/760
 * @Other: 
 */

const fs = require('fs');
const path = require('path');

const _etcSettings = {
    // // 安卓原生平台
    // "android": {
    //     "formats": [
    //         {
    //             "name": "etc1",
    //             "quality": "fast"
    //         }
    //     ]
    // },

    // iOS原生平台
    // "ios": {
    //     "formats": [
    //         {
    //             "name": "pvrtc_2bits",
    //             "quality": "high"
    //         }
    //     ]
    // },

    // // 小游戏平台
    // "minigame": {
    //     "formats": [
    //         {
    //             "name": "etc1",
    //             "quality": "slow"
    //         },
    //         {
    //             "name": "pvrtc_2bits",
    //             "quality": "high"
    //         }
    //     ]
    // }

    "web": {
        "formats": [
            {
                "name": "webp",
                "quality": 80
            }
        ]
    }
};

// 读取的目录
let sourcePath = process.argv[2];

// 1是设置，0还原成默认
let isCompress = parseInt(process.argv[3]);

// 排除不需要压缩纹理的目录
let excludeDirArray = ['long', 'fishamin', 'spine'];

let lookupDir = function (url) {
    if (!fs.existsSync(url)) {
        return;
    }
    fs.readdir(url, (err, files) => {
        if (err) {
            console.error(err);
            return;
        }
        files.forEach((file) => {
            let curPath = path.join(url, file);
            let stat = fs.statSync(curPath);
            if (stat.isDirectory()) {
                if (isCompress === 1) {
                    if (!excludeDirArray.includes(file)) {
                        lookupDir(curPath); // 遍历目录
                    };
                } else {
                    lookupDir(curPath); // 遍历目录
                };
            } else {
                if (file.indexOf('.meta') >= 0) {
                    fs.readFile(curPath, (err, data) => {
                        if (err) {
                            console.error(err);
                            return;
                        }
                        let obj = JSON.parse(data);
                        if (obj && obj.platformSettings) {
                            obj.platformSettings = isCompress ? _etcSettings : {}; // 设置压缩纹理
                            let wrdata = JSON.stringify(obj, null, 2);
                            fs.writeFile(curPath, wrdata, (err) => {
                                if (err) {
                                    console.error(err);
                                    return;
                                }
                            });
                        }
                    });
                }
            }
        });
    });
}

if (!path.isAbsolute(sourcePath)) {
    sourcePath = path.join(__dirname, sourcePath)
}
lookupDir(sourcePath);